(function ($, Drupal) {
  "use strict";

  Drupal.behaviors.fieldComposeYamlEditor = {
    attach: function (context) {
      var initEditor = function () {
        $('textarea', context).once('yaml-editor').each(function () {
          var $textarea = $(this);
          var $editDiv = $('<div>').insertBefore($textarea);

          $textarea.addClass('visually-hidden');

          // Init ace editor.
          var editor = ace.edit($editDiv[0]);
          editor.getSession().setValue($textarea.val());
          editor.getSession().setTabSize(2);
          editor.setOptions({
            minLines: 3,
            maxLines: 20
          });

          // Update textarea value.
          editor.getSession().on('change', function () {
            $textarea.val(editor.getSession().getValue());
          });
        });
      };

      if (typeof ace !== 'undefined') {
        initEditor();
      }
    }
  };

})(jQuery, Drupal);
